'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2009
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports System.ComponentModel
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Xml

Namespace DotNetNuke.UI.WebControls
	Public Class HTMLElement

		Private m_strRaw As String
		Private m_strText As String
		Private m_strTagName As String
		Private m_objAttributes As Hashtable = New Hashtable

#Region "Constructors"
		Public Sub New(ByVal TagName As String)
			m_strTagName = TagName
		End Sub
#End Region

		Public Property Raw() As String
			Get
				Return m_strRaw
			End Get
			Set(ByVal Value As String)
				m_strRaw = Value
			End Set
		End Property

		Public Property Text() As String
			Get
				Return m_strText
			End Get
			Set(ByVal Value As String)
				m_strText = Value
			End Set
		End Property

		Public Property TagName() As String
			Get
				Return m_strTagName
			End Get
			Set(ByVal Value As String)
				m_strTagName = Value
			End Set
		End Property

		Public ReadOnly Property Attributes() As Hashtable
			Get
				Return m_objAttributes
			End Get
		End Property

		Public Function ToJSON() As String
			Dim sb As System.Text.StringBuilder = New System.Text.StringBuilder
			For Each strAttr As String In Me.Attributes.Keys
				If sb.Length = 0 Then
					sb.Append("{")
				Else
					sb.Append(",")
				End If
				sb.Append(String.Format("{0}:{1}", strAttr, SafeJSONString(CStr(Me.Attributes(strAttr)))))
			Next
			If Len(Me.Text) > 0 Then
				If sb.Length = 0 Then
					sb.Append("{")
				Else
					sb.Append(",")
				End If
				sb.Append(String.Format("{0}:{1}", "__text", SafeJSONString(Me.Text)))
			End If
			sb.Append("}")
			Return sb.ToString
		End Function

		Private Function SafeJSONString(ByVal strString As String) As String
			'TODO: Move this to Utility. ClientAPI!
            Return "'" & Replace(Replace(Replace(strString, vbCr, "\r"), vbLf, "\n"), "'", "\'") & "'"
		End Function

	End Class
End Namespace