'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2009
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports System.Collections
Imports System.Web.UI

Namespace DotNetNuke.UI.WebControls
	Public Class HTMLElementCollection
		Inherits CollectionBase

		Public Sub New()
			MyBase.New()
		End Sub

		Default Public Property Item(ByVal index As Integer) As HTMLElement
			Get
				Return CType(List(index), HTMLElement)
			End Get
			Set(ByVal Value As HTMLElement)
				List(index) = Value
			End Set
		End Property

		Public Function Add(ByVal value As HTMLElement) As Integer
			Dim index As Integer = List.Add(value)
			Return index
		End Function

		Public Sub AddRange(ByVal value As HTMLElement())
			For i As Integer = 0 To value.Length - 1
				Add(value(i))
			Next i
		End Sub

		Public Function IndexOf(ByVal value As HTMLElement) As Integer
			'Return List.IndexOf(value)
		End Function

		Public Function Contains(ByVal value As HTMLElement) As Boolean
			'Return List.Contains(value)
		End Function		  'Contains

		Public Sub Insert(ByVal index As Integer, ByVal value As HTMLElement)
			List.Insert(index, value)
		End Sub

		Public Sub Remove(ByVal value As HTMLElement)
			List.Remove(value)
		End Sub		  'Remove

		Public Sub CopyTo(ByVal array As HTMLElement(), ByVal index As Integer)
			List.CopyTo(array, index)
		End Sub

		Public Overrides Function ToString() As String
			Dim objSB As Text.StringBuilder = New Text.StringBuilder
			For Each objElement As HTMLElement In list
				objSB.Append(objElement.Raw)
			Next
			Return objSB.ToString
		End Function

		Public Function ToJSON() As String
			Return ToJSON("")
		End Function

		Public Function ToJSON(ByVal KeyAttribute As String) As String
			Dim strKey As String
			Dim objSB As Text.StringBuilder = New Text.StringBuilder
			Dim iNotFoundCount As Integer
			objSB.Append("{")
			For Each objElement As HTMLElement In list
				If objSB.Length > 1 Then objSB.Append(",")
				If objElement.Attributes.Contains(KeyAttribute) Then
					strKey = CStr(objElement.Attributes(KeyAttribute))
				Else
					iNotFoundCount += 1
					strKey = "__" & iNotFoundCount.ToString
				End If
				objSB.Append(strKey & ":" & objElement.ToJSON)
			Next
			objSB.Append("}")

			Return objSB.ToString
		End Function

	End Class
End Namespace

