'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2009
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System.Web.UI
Imports DotNetNuke.UI.Utilities

Namespace DotNetNuke.UI.WebControls

	Public Enum eClickAction
		PostBack
		Expand
		None
		Navigate
	End Enum

	Public Enum Orientation
		Horizontal
		Vertical
	End Enum

    Public Enum Alignment
        Top
        Left
        Bottom
        Right
    End Enum

    Public Enum UrlFormatType
        None
        AbsoluteWithoutServer
        Relative
    End Enum

    Public Module WebControls

        Public Function IsDesignMode() As Boolean
            'If Not objControl.Site Is Nothing AndAlso objControl.Site.DesignMode = True Then
            If System.Web.HttpContext.Current Is Nothing Then
                Return True
            End If
            Return False
        End Function

        Public Function StripUrlPaths(ByVal Text As String, ByVal Type As UrlFormatType, ByVal ThePage As Page) As String
            '  Using Expresso Version: 3.0.2559, http://www.ultrapico.com
            '  
            '  A description of the regular expression:
            '  
            '  Change options within a new noncapturing group [i:]. [(?<=(?:src|href)=(?:"|'))http://www.solpart.com/(?=[^'|"]*?(?:"|'))]
            '      Turn ON Ignore Case option
            '      (?<=(?:src|href)=(?:"|'))[SERVER URL](?=[^'|"]*?(?:"|'))
            '          Match a prefix but exclude it from the capture. [(?:src|href)=(?:"|')]
            '              (?:src|href)=(?:"|')
            '                  Match expression but don't capture it. [src|href]
            '                      Select from 2 alternatives
            '                          src
            '                              src
            '                          href
            '                              href
            '                  =
            '                  Match expression but don't capture it. ["|']
            '                      Select from 2 alternatives
            '                          "'
            '          [SERVER URL]
            '          Match a suffix but exclude it from the capture. [[^'|"]*?(?:"|')]
            '              [^'|"]*?(?:"|')
            '                  Any character that is NOT in this class: ['|"], any number of repetitions, as few as possible
            '                  Match expression but don't capture it. ["|']
            '                      Select from 2 alternatives
            '                          "'
            '  
            '  
            If ThePage Is Nothing Then
                Return Text
            End If

            Dim strTemp As String
            Dim strStripPortion As String

            Select Case Type
                Case UrlFormatType.AbsoluteWithoutServer
                    'strip just server off - keep absolute url
                    strTemp = ThePage.Request.Url.AbsoluteUri
                    strStripPortion = strTemp.Substring(0, strTemp.Length - ThePage.Request.Url.PathAndQuery.Length)
                Case UrlFormatType.Relative
                    'make relative urls
                    strTemp = ThePage.Request.Path.Substring(ThePage.Request.Path.LastIndexOf("/") + 1)
                    strStripPortion = ThePage.Request.Url.AbsoluteUri.Substring(0, ThePage.Request.Url.AbsoluteUri.IndexOf(strTemp))
            End Select

            strStripPortion = System.Text.RegularExpressions.Regex.Escape(strStripPortion)  'escape things like . with \.
            Dim strExpression As String = String.Format("(?i:(?<=(?:src|href)=(?:""|')){0}(?=[^'|""]*?(?:""|')))", strStripPortion)
            Return System.Text.RegularExpressions.Regex.Replace(Text, strExpression, "")

        End Function

        Public Function ToJSON(ByVal hash As Hashtable) As String
            Dim sb As System.Text.StringBuilder = New System.Text.StringBuilder()
            Dim value As String = ""
            sb.Append("{")
            For Each strKey As String In hash.Keys
                If sb.Length > 1 Then sb.Append(",")
                'If TypeOf (hash(strKey)) Is String Then
                'treat everything as string for now
                If True Then
                    value = CStr(hash(strKey))
                    value = "'" & ClientAPI.EscapeForJavascript(CStr(value)) & "'"
                Else
                    value = CStr(hash(strKey))
                End If
                sb.Append(strKey & ":" & value)
            Next
            sb.Append("}")

            Return sb.ToString
        End Function

        Public Sub RegisterClientScriptBlock(ByVal ThePage As Page, ByVal Key As String)
            If DotNetNuke.UI.Utilities.ClientAPI.UseExternalScripts Then
                MSAJAX.RegisterClientScript(ThePage, ThePage.ResolveUrl(DotNetNuke.UI.Utilities.ClientAPI.ScriptPath & Key))
            Else
                MSAJAX.RegisterClientScript(ThePage, Key, "DotNetNuke.WebControls")
            End If
        End Sub

        Public Sub RegisterSubmitComponent(ByVal ThePage As Page)
            If ThePage.ClientScript.IsOnSubmitStatementRegistered(ThePage.GetType(), "dnn.controls.submitComp") = False Then
                RegisterClientScriptBlock(ThePage, "dnn.controls.js")
                ThePage.ClientScript.RegisterOnSubmitStatement(ThePage.GetType(), "dnn.controls.submitComp", "dnn.controls.submitComp.onsubmit()")
            End If
        End Sub


        Public Function GetNodeJS(ByVal NavControl As Control, ByVal Node As DNNNode, ByVal DefaultJS As String, ByVal Target As String, ByVal NoneDoesPostBack As Boolean) As String
            Dim js As String = ""
            If Len(Node.JSFunction) > 0 Then
                js = FixJs(Node.JSFunction)
            ElseIf Len(DefaultJS) > 0 Then
                js = FixJs(DefaultJS)
            End If

            Select Case Node.ClickAction
                Case eClickAction.PostBack, eClickAction.Expand, eClickAction.None                    'none included since downlevel
                    If Node.ClickAction <> eClickAction.None OrElse NoneDoesPostBack Then
                        If Len(js) > 0 Then js = "if (eval(""" & js.Replace("""", """""") & """) != false) "
                        js &= NavControl.Page.ClientScript.GetPostBackEventReference(NavControl, Node.ID & DotNetNuke.UI.Utilities.ClientAPI.COLUMN_DELIMITER & "Click")
                    End If
                Case eClickAction.Navigate
                    If Len(js) > 0 Then js = "if (eval(""" & js.Replace("""", """""") & """) != false) "
                    If Len(Target) > 0 Then
                        js &= "window.frames." & Target & ".location.href='" & Node.NavigateURL & "'; void(0);"                         'FOR SOME REASON THIS DOESNT WORK UNLESS WE HAVE CODE AFTER THE SETTING OF THE HREF...
                    Else
                        If String.IsNullOrEmpty(js) = False Then
                            js &= "window.location.href='" & Node.NavigateURL & "';"
                        End If
                    End If
            End Select
            Return js

        End Function

        Private Function FixJs(ByVal js As String) As String
            If String.IsNullOrEmpty(js) = False AndAlso js.EndsWith(";") = False Then
                Return js & ";"
            End If
            Return js
        End Function


    End Module

End Namespace