'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2009
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'
Imports System.ComponentModel
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Xml
Imports System.Drawing

Imports System
Imports System.IO
Imports System.Web

Imports System.Windows.Forms.Design
Imports System.Drawing.Design

Namespace DotNetNuke.UI.WebControls

	Public Class DNNMenuDesigner : Inherits System.Web.UI.Design.ControlDesigner
		'--- This class allows us to render the design time mode with custom HTML ---'
		Public Overrides Function GetDesignTimeHtml() As String
			' Component is the instance of the component or control that
			' this designer object is associated with. This property is 
			' inherited from System.ComponentModel.ComponentDesigner.
			Dim objMenu As DNNMenu = CType(Component, DNNMenu)

			If objMenu.ID.Length > 0 Then
				Dim sw As New StringWriter
				Dim tw As New HtmlTextWriter(sw)
				Dim objText As Label = New Label

				objText.CssClass = objMenu.MenuBarCssClass & " " & objMenu.DefaultNodeCssClass
				objText.Text = objMenu.ID

				If objMenu.Orientation = Orientation.Horizontal Then
					objText.Width = New Unit("100%")
					'objText.Height = New Unit(objMenu)
				Else
					objText.Height = New Unit(500)					 '---not sure why 100% doesn't work here ---' 'Unit("100%")
					'objText.Width = Unit.Empty
				End If
				objText.RenderControl(tw)
				Return sw.ToString()
            Else
                Return Nothing
            End If
		End Function

		Public Overrides ReadOnly Property AllowResize() As Boolean
			Get
				Return False
			End Get
		End Property
	End Class
End Namespace
