'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2009
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports DotNetNuke.UI.Utilities
Imports System.Collections.Generic

Namespace DotNetNuke.UI.WebControls

    Friend Class DNNMenuListWriter
        Inherits WebControl
        Implements IDNNMenuWriter
        Private m_Menu As DNNMenu

        Public Sub New()
            MyBase.New(HtmlTextWriterTag.Div)
        End Sub

        Public Sub RenderMenu(ByVal writer As HtmlTextWriter, ByVal Menu As DNNMenu) Implements IDNNMenuWriter.RenderMenu
            m_Menu = Menu
            RenderControl(writer)
        End Sub

        Protected Overloads Overrides Sub RenderContents(ByVal writer As HtmlTextWriter)
            'writer.AddAttribute(HtmlTextWriterAttribute.Width, "100%")
            writer.AddAttribute(HtmlTextWriterAttribute.Class, m_Menu.CssClass)
            'writer.AddAttribute(HtmlTextWriterAttribute.Name, m_Menu.UniqueID)
            writer.AddAttribute(HtmlTextWriterAttribute.Id, m_Menu.ClientID)

            writer.RenderBeginTag(HtmlTextWriterTag.Ul)
            RenderChildren(writer)
            writer.RenderEndTag()
        End Sub

        Protected Overloads Overrides Sub RenderChildren(ByVal writer As HtmlTextWriter)
            Dim TempNode As MenuNode
            For Each TempNode In m_Menu.MenuNodes
                TempNode.Render(writer)
            Next
        End Sub

    End Class
End Namespace
