'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2009
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports System.Web.UI
Imports System.Web.UI.WebControls
Namespace DotNetNuke.UI.WebControls

	Friend Class DNNMenuWriter
		Inherits WebControl
		Implements IDNNMenuWriter
		Private m_objMenu As DNNMenu
		Private m_blnForceFullMenu As Boolean

		Public Property ForceFullMenu() As Boolean
			Get
				Return m_blnForceFullMenu
			End Get
			Set(ByVal Value As Boolean)
				m_blnForceFullMenu = Value
			End Set
		End Property

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' 
		''' </summary>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[jhenning]	9/21/2005	Created
		''' </history>
		''' -----------------------------------------------------------------------------
		Public Sub New()
		End Sub

		Public Sub New(ByVal blnForceFullMenu As Boolean)
			Me.ForceFullMenu = blnForceFullMenu
		End Sub

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' 
		''' </summary>
		''' <param name="writer"></param>
		''' <param name="Menu"></param>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[jhenning]	9/21/2005	Created
		''' </history>
		''' -----------------------------------------------------------------------------
		Public Sub RenderMenu(ByVal writer As HtmlTextWriter, ByVal Menu As DNNMenu) Implements IDNNMenuWriter.RenderMenu
			m_objMenu = Menu
			RenderControl(writer)
		End Sub


		''' -----------------------------------------------------------------------------
		''' <summary>
		''' 
		''' </summary>
		''' <param name="writer"></param>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[jhenning]	9/21/2005	Created
		''' </history>
		''' -----------------------------------------------------------------------------
		Protected Overloads Overrides Sub RenderContents(ByVal writer As HtmlTextWriter)
			Dim strClass As String = "DNNMenu "
			If m_objMenu.SelectedMenuNodes.Count = 0 Then
				If Len(m_objMenu.MenuBarCssClass) > 0 Then strClass &= m_objMenu.MenuBarCssClass
			Else
				If Len(m_objMenu.MenuCssClass) > 0 Then strClass &= m_objMenu.MenuCssClass
			End If
			writer.AddAttribute(HtmlTextWriterAttribute.Width, "100%")
			writer.AddAttribute(HtmlTextWriterAttribute.Class, strClass)
			writer.AddAttribute(HtmlTextWriterAttribute.Name, m_objMenu.UniqueID)
			writer.AddAttribute(HtmlTextWriterAttribute.Id, m_objMenu.ClientID)


			writer.RenderBeginTag(HtmlTextWriterTag.Div)
			RenderChildren(writer)
			writer.RenderEndTag()
		End Sub

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' 
		''' </summary>
		''' <param name="writer"></param>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[jhenning]	9/21/2005	Created
		''' </history>
		''' -----------------------------------------------------------------------------
		Protected Overloads Overrides Sub RenderChildren(ByVal writer As HtmlTextWriter)
			Dim TempNode As MenuNode
			For Each TempNode In m_objMenu.MenuNodes
				TempNode.Render(writer)
			Next
		End Sub

	End Class
End Namespace
