'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2009
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Diagnostics
Imports DotNetNuke.UI.Utilities
Namespace DotNetNuke.UI.WebControls

    Friend Class MenuNodeListWriter
        Implements IMenuNodeWriter
        Private m_Node As MenuNode
        Private m_eOrientation As Orientation

        Public Property Orientation() As Orientation
            Get
                Return m_eOrientation
            End Get
            Set(ByVal Value As Orientation)
                m_eOrientation = Value
            End Set
        End Property

        Public Sub New()

        End Sub

        Public Sub New(ByVal eOrientation As Orientation)
            Me.Orientation = eOrientation
        End Sub

        Public Sub RenderNode(ByVal writer As HtmlTextWriter, ByVal Node As MenuNode) Implements IMenuNodeWriter.RenderNode
            m_Node = Node
            Render(writer)
        End Sub

        Protected Sub Render(ByVal writer As HtmlTextWriter)
            RenderOpenTag(writer)
            Dim lnk As HyperLink = GetLink()
            RenderNodeIcon(lnk)
            RenderNodeText(lnk)
            RenderNodeArrow(lnk)
            lnk.RenderControl(writer)

            If m_Node.HasNodes Then
                'writer.AddAttribute(HtmlTextWriterAttribute.Class, "Child")
                'writer.AddAttribute(HtmlTextWriterAttribute.Width, "100%")
                writer.AddAttribute(HtmlTextWriterAttribute.Id, GetChildControlID(m_Node.ID, "sub"))
                'writer.RenderBeginTag(HtmlTextWriterTag.Div)
                writer.RenderBeginTag(HtmlTextWriterTag.Ul)
                RenderChildren(writer)
                writer.RenderEndTag()
                'writer.RenderEndTag()
            End If
            writer.RenderEndTag()
        End Sub

        Protected Sub RenderChildren(ByVal writer As HtmlTextWriter)
            For Each _elem As MenuNode In m_Node.MenuNodes
                _elem.Render(writer)
            Next
        End Sub

        Protected Sub RenderOpenTag(ByVal writer As HtmlTextWriter)
            'writer.AddAttribute(HtmlTextWriterAttribute.Name, m_Node.ID)
            writer.AddAttribute(HtmlTextWriterAttribute.Id, GetChildControlID(m_Node.ID, "ctr"))
            writer.RenderBeginTag(HtmlTextWriterTag.Li)

        End Sub

        Private Function GetChildControlID(ByVal NodeID As String, ByVal Prefix As String) As String
            Return String.Format("{0}{1}{2}", m_Node.DNNMenu.ClientID, Prefix, NodeID)
        End Function

        Protected Sub RenderNodeIcon(ByVal parent As Control)
            'Dim span As Label = New Label
            Dim css As String = ""
            If Len(m_Node.CSSIcon) > 0 Then
                css = m_Node.CSSIcon
                '    span.CssClass = m_Node.CSSIcon
            ElseIf Len(m_Node.DNNMenu.DefaultIconCssClass) > 0 Then
                '    span.CssClass = m_Node.DNNMenu.DefaultIconCssClass
                css = m_Node.DNNMenu.DefaultIconCssClass
            End If
            'If span.CssClass.Trim().Length > 0 Then
            '    parent.Controls.Add(span)
            '    parent = span
            'End If
            If m_Node.ImageIndex > -1 Then
                'span.RenderBeginTag(writer)

                If m_Node.ImageIndex > -1 Then
                    Dim m_NodeImage As NodeImage = m_Node.DNNMenu.ImageList(m_Node.ImageIndex)
                    If Not (m_NodeImage Is Nothing) Then
                        Dim img As Image = New Image
                        img.ImageUrl = m_NodeImage.ImageUrl
                        img.AlternateText = " "
                        img.CssClass = css
                        'img.RenderControl(writer)
                        parent.Controls.Add(img)
                        'writer.Write("&nbsp;")
                    End If
                    'Else
                    '    Dim img As Image = New Image
                    '    img.ImageUrl = Me.m_Node.DNNMenu.SystemImagesPath & "spacer.gif"
                    '    img.RenderControl(writer)
                    '    img.CssClass = span.CssClass
                    '    'writer.Write("&nbsp;")
                End If
                'span.RenderEndTag(writer)
            End If
        End Sub

        Protected Sub RenderNodeArrow(ByVal parent As Control)
            If m_Node.HasNodes Then
                Dim img As Image = Nothing
                If m_Node.Level = 0 Then
                    If Len(m_Node.DNNMenu.RootArrowImage) > 0 Then
                        img = New Image()
                        img.ImageUrl = m_Node.DNNMenu.RootArrowImage
                    End If
                Else
                    If Len(m_Node.DNNMenu.ChildArrowImage) > 0 Then
                        img = New Image()
                        img.ImageUrl = m_Node.DNNMenu.ChildArrowImage
                    End If
                End If
                If Not img Is Nothing Then
                    parent.Controls.Add(img)
                End If
            End If
        End Sub

        Private Function GetLink() As HyperLink
            Dim lnk As HyperLink = New HyperLink()

            If m_Node.Enabled AndAlso m_Node.ClickAction = eClickAction.Navigate Then
                lnk.NavigateUrl = m_Node.NavigateURL
            End If
            Return lnk
        End Function

        Protected Sub RenderNodeText(ByVal parent As Control)

            Dim lbl As Label = New Label
            lbl.Text = m_Node.Text
            If Len(m_Node.ToolTip) > 0 Then
                lbl.ToolTip = m_Node.ToolTip
            End If
            parent.Controls.Add(lbl)
        End Sub

    End Class
End Namespace
