'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2009
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Diagnostics
Imports DotNetNuke.UI.Utilities
Namespace DotNetNuke.UI.WebControls

	Friend Class MenuNodeWriter
		Implements IMenuNodeWriter
        Private m_Node As MenuNode
        Private m_blnForceFullMenu As Boolean
        Private m_eOrientation As Orientation

        Public Property ForceFullMenu() As Boolean
            Get
                Return m_blnForceFullMenu
            End Get
            Set(ByVal Value As Boolean)
                m_blnForceFullMenu = Value
            End Set
        End Property
        Public Property Orientation() As Orientation
            Get
                Return m_eOrientation
            End Get
            Set(ByVal Value As Orientation)
                m_eOrientation = Value
            End Set
        End Property

        Public Sub New()

        End Sub

        Public Sub New(ByVal blnForceFullMenu As Boolean)
            Me.ForceFullMenu = blnForceFullMenu
        End Sub

        Public Sub New(ByVal blnForceFullMenu As Boolean, ByVal eOrientation As Orientation)
            Me.ForceFullMenu = blnForceFullMenu
            Me.Orientation = eOrientation
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' 
        ''' </summary>
        ''' <param name="writer"></param>
        ''' <param name="Node"></param>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[jhenning]	9/21/2005	Created
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Public Sub RenderNode(ByVal writer As HtmlTextWriter, ByVal Node As MenuNode) Implements IMenuNodeWriter.RenderNode
            m_Node = Node
            Render(writer)
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' 
        ''' </summary>
        ''' <param name="writer"></param>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[jhenning]	9/21/2005	Created
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Protected Sub Render(ByVal writer As HtmlTextWriter)
            Dim objLastNode As MenuNode
            Dim strParentID As String
            If m_Node.DNNMenu.SelectedMenuNodes.Count > 0 Then
                objLastNode = CType(m_Node.DNNMenu.SelectedMenuNodes(m_Node.DNNMenu.SelectedMenuNodes.Count), MenuNode)
            End If

            If Not m_Node.Parent Is Nothing Then strParentID = m_Node.Parent.ID

            If objLastNode Is Nothing OrElse m_Node.Selected OrElse objLastNode.ID = m_Node.ID OrElse objLastNode.ID = strParentID OrElse _
                (Not objLastNode.Parent Is Nothing AndAlso objLastNode.Parent.ID = strParentID) OrElse Me.ForceFullMenu Then
                If Not objLastNode Is Nothing AndAlso objLastNode.ID = m_Node.ID AndAlso String.IsNullOrEmpty(strParentID) = False AndAlso strParentID <> Me.m_Node.DNNMenu.ClientID Then
                    RenderParentLink(writer, strParentID)
                End If
                RenderContents(writer)
            End If

            If m_Node.HasNodes AndAlso (m_Node.Selected OrElse Me.ForceFullMenu) Then
                writer.AddAttribute(HtmlTextWriterAttribute.Class, "Child")
                writer.AddAttribute(HtmlTextWriterAttribute.Width, "100%")
                If Me.ForceFullMenu OrElse Me.Orientation = Orientation.Vertical Then
                    writer.RenderBeginTag(HtmlTextWriterTag.Div)
                Else
                    writer.RenderBeginTag(HtmlTextWriterTag.Span)
                End If
                RenderChildren(writer)
                writer.RenderEndTag()
            ElseIf Not objLastNode Is Nothing AndAlso objLastNode.Level > m_Node.Level Then
                RenderChildren(writer)
            End If
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' 
        ''' </summary>
        ''' <param name="writer"></param>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[jhenning]	9/21/2005	Created
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Protected Sub RenderContents(ByVal writer As HtmlTextWriter)

            RenderOpenTag(writer)

            RenderNodeIcon(writer)

            RenderNodeText(writer)

            RenderNodeArrow(writer)

            writer.RenderEndTag()

        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' 
        ''' </summary>
        ''' <param name="writer"></param>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[jhenning]	9/21/2005	Created
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Protected Sub RenderOpenTag(ByVal writer As HtmlTextWriter)
            Dim NodeClass As String = "Node"

            'writer.AddAttribute(HtmlTextWriterAttribute.Class, GetNodeCss(m_Node))
            writer.AddAttribute(HtmlTextWriterAttribute.Name, m_Node.ID)
            writer.AddAttribute(HtmlTextWriterAttribute.Id, m_Node.ID)
            If Me.ForceFullMenu OrElse Me.Orientation = Orientation.Vertical Then
                writer.AddStyleAttribute("padding-left", (m_Node.Level * 20).ToString & "px")                  'WARNING:  HARDCODE
                writer.RenderBeginTag(HtmlTextWriterTag.Div)
            Else
                writer.RenderBeginTag(HtmlTextWriterTag.Span)
            End If

        End Sub


        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' 
        ''' </summary>
        ''' <param name="writer"></param>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[jhenning]	9/21/2005	Created
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Protected Sub RenderNodeIcon(ByVal writer As HtmlTextWriter)
            Dim oSpan As Label = New Label
            If Len(m_Node.CSSIcon) > 0 Then
                oSpan.CssClass = m_Node.CSSIcon
            ElseIf Len(m_Node.DNNMenu.DefaultIconCssClass) > 0 Then
                oSpan.CssClass = m_Node.DNNMenu.DefaultIconCssClass
            End If
            oSpan.RenderBeginTag(writer)

            If m_Node.ImageIndex > -1 Then
                Dim m_NodeImage As NodeImage = m_Node.DNNMenu.ImageList(m_Node.ImageIndex)
                If Not (m_NodeImage Is Nothing) Then
                    Dim objImage As Image = New Image
                    objImage.ImageUrl = m_NodeImage.ImageUrl
                    objImage.RenderControl(writer)
                    writer.Write("&nbsp;")
                End If
            End If
            oSpan.RenderEndTag(writer)
        End Sub

        Protected Sub RenderNodeArrow(ByVal writer As HtmlTextWriter)
            If m_Node.HasNodes Then
                Dim oSpan As Label = New Label
                oSpan.RenderBeginTag(writer)

                If m_Node.Level = 0 Then
                    If Len(m_Node.DNNMenu.RootArrowImage) > 0 Then
                        Dim objImage As Image = New Image
                        objImage.ImageUrl = m_Node.DNNMenu.RootArrowImage
                        objImage.RenderControl(writer)
                    End If
                Else
                    If Len(m_Node.DNNMenu.ChildArrowImage) > 0 Then
                        Dim objImage As Image = New Image
                        objImage.ImageUrl = m_Node.DNNMenu.ChildArrowImage
                        objImage.RenderControl(writer)
                    End If
                End If
                oSpan.RenderEndTag(writer)
            End If
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' 
        ''' </summary>
        ''' <param name="writer"></param>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[jhenning]	9/21/2005	Created
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Protected Sub RenderNodeText(ByVal writer As HtmlTextWriter)
            Dim lnk As HyperLink = New HyperLink
            Dim menu As DNNMenu = m_Node.DNNMenu

            Dim js As String = WebControls.GetNodeJS(menu, m_Node, menu.JSFunction, menu.Target, True)
            lnk.Text = m_Node.Text

            If m_Node.Enabled Then
                If String.IsNullOrEmpty(js) Then
                    lnk.NavigateUrl = m_Node.NavigateURL
                Else
                    lnk.NavigateUrl = "javascript:" & js
                End If
            Else
                lnk.NavigateUrl = ClientAPI.GetPostBackClientHyperlink(menu, m_Node.ID & ClientAPI.COLUMN_DELIMITER & "Click")
            End If

            If Len(m_Node.ToolTip) > 0 Then
                lnk.ToolTip = m_Node.ToolTip
            End If

            Dim sCSS As String = GetNodeCss(m_Node)
            If Len(sCSS) > 0 Then lnk.CssClass = sCSS
            lnk.RenderControl(writer)
        End Sub

        Protected Sub RenderParentLink(ByVal writer As HtmlTextWriter, ByVal ID As String)
            Dim lnk As HyperLink = New HyperLink
            Dim menu As DNNMenu = m_Node.DNNMenu
            lnk.Text = "..\"
            lnk.NavigateUrl = ClientAPI.GetPostBackClientHyperlink(menu, ID & ClientAPI.COLUMN_DELIMITER & "Click")
            lnk.RenderControl(writer)
        End Sub

        Private Function GetNodeCss(ByVal oNode As MenuNode) As String
            Dim sNodeCss As String = oNode.DNNMenu.CssClass

            If oNode.Level > 0 Then sNodeCss = oNode.DNNMenu.DefaultChildNodeCssClass
            If Len(oNode.CSSClass) > 0 Then sNodeCss = oNode.CSSClass

            If oNode.Selected Then
                If Len(oNode.CSSClassSelected) > 0 Then
                    sNodeCss &= " " & oNode.CSSClassSelected
                Else
                    sNodeCss &= " " & oNode.DNNMenu.DefaultNodeCssClassSelected
                End If
            End If

            Return sNodeCss
        End Function

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' 
        ''' </summary>
        ''' <param name="writer"></param>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[jhenning]	9/21/2005	Created
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Protected Sub RenderChildren(ByVal writer As HtmlTextWriter)
            For Each _elem As MenuNode In m_Node.MenuNodes
                _elem.Render(writer)
            Next
        End Sub

	End Class
End Namespace
