'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2009
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports System.Web.UI
Imports System.ComponentModel

Namespace DotNetNuke.UI.WebControls

    <ParseChildren(False), PersistChildren(True)> _
    Public Class DNNMultiState

        Friend Parent As DNNMultiStateBox

        Private m_Key As String = ""
        Private m_Text As String = ""
        Private m_ImageUrl As String = ""
        Private m_DisabledImageUrl As String = ""
        Private m_ToolTip As String = ""

#Region "Constructors"
        Public Sub New()
        End Sub
        Public Sub New(ByVal Key As String, ByVal Text As String, ByVal ImageUrl As String, ByVal DisabledImageUrl As String, ByVal ToolTip As String)
            m_Key = Key
            m_Text = Text
            m_ImageUrl = ImageUrl
            m_DisabledImageUrl = DisabledImageUrl
            m_ToolTip = ToolTip
        End Sub
#End Region

#Region "Properties"

        <NotifyParentProperty(True)> _
        Public Property Key() As String
            Get
                Return m_Key
            End Get
            Set(ByVal Value As String)
                m_Key = Value
                NotifyDesigner()
            End Set
        End Property

        <DefaultValue(""), Category("Appearance"), NotifyParentProperty(True)> _
        Public Property Text() As String
            Get
                Return m_Text
            End Get
            Set(ByVal Value As String)
                m_Text = Value
                NotifyDesigner()
            End Set
        End Property

        <DefaultValue(""), Category("Appearance"), NotifyParentProperty(True)> _
        Public Property ToolTip() As String
            Get
                Return m_ToolTip
            End Get
            Set(ByVal Value As String)
                m_ToolTip = Value
                NotifyDesigner()
            End Set
        End Property

        <DefaultValue(""), Category("Appearance"), NotifyParentProperty(True)> _
        Public Property ImageUrl() As String
            Get
                Return m_ImageUrl
            End Get
            Set(ByVal Value As String)
                m_ImageUrl = Value
                NotifyDesigner()
            End Set
        End Property

        <DefaultValue(""), Category("Appearance"), NotifyParentProperty(True)> _
        Public Property DisabledImageUrl() As String
            Get
                Return m_DisabledImageUrl
            End Get
            Set(ByVal Value As String)
                m_DisabledImageUrl = Value
                NotifyDesigner()
            End Set
        End Property

#End Region

#Region "Public Methods"
        Friend Sub NotifyDesigner()
            If (Not Me.Parent Is Nothing) Then
                Me.Parent.NotifyDesigner()
            End If
        End Sub

#End Region
    End Class
End Namespace