'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2009
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System.Web.UI
Imports System.Collections
Imports System.Reflection
Imports System.ComponentModel
Imports System.Drawing.Design

Namespace DotNetNuke.UI.WebControls
    <DefaultMember("Item")> _
    Public Class DNNMultiStateCollection : Inherits CollectionBase

        Private m_ctl As DNNMultiStateBox

        Public Sub New(ByVal ctl As DNNMultiStateBox)
            m_ctl = ctl
        End Sub

        Public Sub Add(ByVal Item As DNNMultiState)
            MyBase.InnerList.Add(Item)
        End Sub

        Public Sub AddAt(ByVal index As Integer, ByVal Item As DNNMultiState)
            MyBase.InnerList.Insert(index, Item)
        End Sub

        Protected Overrides Sub OnInsert(ByVal index As Integer, ByVal value As Object)
            Dim state As DNNMultiState = TryCast(value, DNNMultiState)
            state.Parent = Me.m_ctl
            m_ctl.NotifyDesigner()
        End Sub

        Default Public Property Item(ByVal index As Integer) As DNNMultiState
            Get
                Return TryCast(MyBase.InnerList.Item(index), DNNMultiState)
            End Get
            Set(ByVal value As DNNMultiState)
                MyBase.InnerList.Item(index) = value
            End Set
        End Property













    End Class
End Namespace