'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2009
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports DotNetNuke.UI.WebControls
Imports System.ComponentModel
Imports System.ComponentModel.Design
Imports System.Text
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.Design

'since supporting 1.x of the framework, the panels are not going to be updateable.  Once we move firmly on the 2.0
'platform we will make updateable regions and provide a much richer design-time experience
'http://scottonwriting.net/sowblog/posts/1646.aspx 

Namespace DotNetNuke.UI.Design.WebControls
	Public Class DNNTabStripDesigner : Inherits ControlDesigner
		''' -----------------------------------------------------------------------------
		''' <summary>
		''' This class allows us to render the design time mode with custom HTML
		''' </summary>
		''' <remarks>
		''' The reason for implementing this class is to allow a default tabstrip to be 
		''' shown at design-time, when no tabs are present in the html
		''' </remarks>
		''' <history>
		''' 	[Jon Henning]	8/7/2006	Commented
		''' </history>
		''' -----------------------------------------------------------------------------
		Public Overrides Function GetDesignTimeHtml() As String
			Dim strText As String
			Dim objTabStrip As DNNTabStrip = DirectCast(MyBase.Component, DNNTabStrip)
			Dim objTabs As TabStripTabCollection = objTabStrip.Tabs
			Dim blnFDL As Boolean = objTabStrip.ForceDownLevel			 'store original before setting to true
			objTabStrip.ForceDownLevel = True			 'force downlevel to cause only one tab to render
			If objTabs.Count = 0 Then
				objTabs.Add(New DNNTab("Tab 1"))
				objTabs.Add(New DNNTab("Tab 2"))
				Dim objPanel As Panel = New Panel
				objPanel.Width = New Unit("100px")
				objPanel.Height = New Unit("50px")
				objTabs(0).Controls.Add(objPanel)
				objTabStrip.SelectedIndex = 0
				strText = MyBase.GetDesignTimeHtml
				objTabs.Clear()
			Else
				strText = MyBase.GetDesignTimeHtml
			End If
			objTabStrip.ForceDownLevel = blnFDL			 'restore original value
			Return strText

		End Function

	End Class
End Namespace
