'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2009
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'
Imports System
Imports System.ComponentModel
Imports System.ComponentModel.Design
Imports System.Text
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.Design
Imports System.Web.UI.WebControls
Imports DotNetNuke.UI.Utilities
Imports System.Web.UI.HtmlControls

Namespace DotNetNuke.UI.WebControls
	<ProvideProperty("Toolbar", GetType(System.Web.UI.Control)), ParseChildren(True, "Buttons"), DefaultProperty("Buttons"), PersistChildren(False), Designer(GetType(DotNetNuke.UI.Design.WebControls.DNNToolBarDesigner))> _
	Public Class DNNToolBar
		Inherits Control
		Implements IExtenderProvider
		'Implements IStateManager

#Region "Member Variables"
		Private m_bMarked As Boolean = False
		Private m_objState As StateBag
		Private m_objButtons As DNNToolBarButtonCollection
#End Region

#Region "Properties"
        <Bindable(True), DefaultValue(""), ClientProperty(), ClientPropertyName("bid")> _
        Public Property BehaviorID() As String
            Get
                Return CType(ViewState("BehaviorID"), String)
            End Get
            Set(ByVal Value As String)
                ViewState("BehaviorID") = Value
            End Set
        End Property

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' Css class name to use for a tab
		''' </summary>
		''' <value></value>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[Jon Henning]	9/15/2006	Commented
		''' </history>
		''' -----------------------------------------------------------------------------
		<Category("Appearance")> _
		Public Property CssClass() As String
			Get
				Return CStr(ViewState("CssClass"))
			End Get
			Set(ByVal value As String)
				ViewState("CssClass") = value
                If WebControls.IsDesignMode Then Me.NotifyDesigner()
            End Set
        End Property

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' Css class name to use on all buttons
		''' </summary>
		''' <value></value>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[Jon Henning]	9/27/2006	Commented
		''' </history>
		''' -----------------------------------------------------------------------------
		<Category("Appearance")> _
		Public Property DefaultButtonCssClass() As String
			Get
				Return CStr(ViewState("DefaultButtonCssClass"))
			End Get
			Set(ByVal value As String)
				ViewState("DefaultButtonCssClass") = value
                If WebControls.IsDesignMode Then Me.NotifyDesigner()
			End Set
		End Property

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' Css class name to use on all buttons when hovered
		''' </summary>
		''' <value></value>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[Jon Henning]	9/27/2006	Commented
		''' </history>
		''' -----------------------------------------------------------------------------
		<Category("Appearance")> _
		Public Property DefaultButtonHoverCssClass() As String
			Get
				Return CStr(ViewState("DefaultButtonHoverCssClass"))
			End Get
			Set(ByVal value As String)
				ViewState("DefaultButtonHoverCssClass") = value
                If WebControls.IsDesignMode Then Me.NotifyDesigner()
			End Set
		End Property

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' Number of milliseconds to wait befor hiding sub-menu on mouse out
		''' </summary>
		''' <value></value>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[Jon Henning]	9/16/2006	Commented
		''' </history>
		''' -----------------------------------------------------------------------------
		<Description("Number of milliseconds to wait befor hiding sub-menu on mouse out"), Category("Behavior"), PersistenceMode(PersistenceMode.Attribute), DefaultValue(250)> _
		 Public Property MouseOutDelay() As Integer
			Get
				If Len(CStr(ViewState("MouseOutDelay"))) = 0 Then
					Return 250
				Else
					Return CType(ViewState("MouseOutDelay"), Integer)
				End If
			End Get
			Set(ByVal Value As Integer)
				ViewState("MouseOutDelay") = Value
                If WebControls.IsDesignMode Then Me.NotifyDesigner()
			End Set
		End Property

		<DesignerSerializationVisibility(DesignerSerializationVisibility.Content), PersistenceMode(PersistenceMode.InnerDefaultProperty)> _
		  Public Overridable ReadOnly Property Buttons() As DNNToolBarButtonCollection
			Get
				If m_objButtons Is Nothing Then
					m_objButtons = New DNNToolBarButtonCollection(Me)					'New Generic.List(Of Tab)
				End If
				Return CType(m_objButtons, DNNToolBarButtonCollection)
			End Get
		End Property

		<Description("Allows toolbar structure to be reused by others sharing the same id"), Category("Behavior"), PersistenceMode(PersistenceMode.Attribute), DefaultValue(False)> _
		  Public Property ReuseToolBar() As Boolean
			Get
				If Len(CStr(ViewState("ReuseToolBar"))) = 0 Then
					Return False
				Else
					Return CType(ViewState("ReuseToolBar"), Boolean)
				End If
			End Get
			Set(ByVal Value As Boolean)
				ViewState("ReuseToolBar") = Value
                If WebControls.IsDesignMode Then Me.NotifyDesigner()
			End Set
		End Property

		<Browsable(False), Bindable(False)> _
		Public Shadows Property Visible() As Boolean
			Get
				Return MyBase.Visible
			End Get
			Set(ByVal Value As Boolean)
				MyBase.Visible = Value
			End Set
		End Property

		<Browsable(False)> _
		Friend ReadOnly Property AttachedControl() As Control
			Get
				Return FindAttachedControl(Page)
			End Get
		End Property

#End Region

#Region "State Management"
		'		Protected ReadOnly Property ViewState() As StateBag
		'			Get
		'				If m_objState Is Nothing Then
		'					m_objState = New StateBag(True)
		'					If IsTrackingViewState Then
		'						CType(m_objState, IStateManager).TrackViewState()
		'					End If
		'				End If
		'				Return m_objState
		'			End Get
		'		End Property

		'		Protected ReadOnly Property IsTrackingViewState() As Boolean Implements System.Web.UI.IStateManager.IsTrackingViewState
		'			Get
		'				Return m_bMarked
		'			End Get
		'		End Property

		'		Protected Sub LoadViewState(ByVal state As Object) Implements System.Web.UI.IStateManager.LoadViewState
		'			If Not (state Is Nothing) Then
		'				CType(ViewState, IStateManager).LoadViewState(state)
		'			End If
		'		End Sub

		'		Protected Function SaveViewState() As Object Implements System.Web.UI.IStateManager.SaveViewState
		'			Dim oState As Object = Nothing
		'			If Not (m_objState Is Nothing) Then
		'				oState = CType(m_objState, IStateManager).SaveViewState()
		'			End If
		'			Return oState
		'		End Function

		'		Protected Sub TrackViewState() Implements System.Web.UI.IStateManager.TrackViewState
		'			m_bMarked = True
		'		End Sub
#End Region

#Region "Old Extender Implementation"
		'		Private m_objTBC As DNNToolBarComponent
		'		Private m_strTarget As String

		'		<Browsable(False)> _
		'		Friend ReadOnly Property HostingControl() As DNNToolBarComponent
		'			Get
		'				If m_objTBC Is Nothing Then
		'					m_objTBC = CType(Me.Parent, DNNToolBarComponent)
		'				End If
		'				Return m_objTBC
		'			End Get
		'			'Set(ByVal value As DNNToolbarComponent)
		'			'	m_objTBC = value
		'			'End Set
		'		End Property

		'		<Browsable(False)> _
		'		 Public Property Target() As String
		'			Get
		'				Return m_strTarget
		'			End Get
		'			Set(ByVal value As String)
		'				m_strTarget = value
		'			End Set
		'		End Property

		'		Friend Sub NotifyDesigner()
		'			If Not Me.HostingControl Is Nothing Then
		'				HostingControl.NotifyDesigner()
		'			End If
		'		End Sub

		'		'Friend Sub SetTarget(ByVal objControl As Control)
		'		'	Me.Target = objControl.ID
		'		'	AddHandler objControl.PreRender, AddressOf DNNToolBar_PreRender
		'		'End Sub

#End Region

#Region "Extender Implementation"
		'for more info see http://www.codeproject.com/aspnet/PropertyExtendersASP20.asp

		Public Function CanExtend(ByVal extendee As Object) As Boolean Implements System.ComponentModel.IExtenderProvider.CanExtend
			Select Case True
				Case TypeOf extendee Is IDNNToolBar
					If CType(extendee, IDNNToolBar).ToolBarId = Me.ID Then
						Return True
					End If
			End Select
			Return False
		End Function

		Public Sub SetToolbar()
			Dim x As Boolean = False
		End Sub

		Public Function GetToolbar(ByVal objControl As Control) As DNNToolBar
			Dim objITB As IDNNToolBar = CType(objControl, IDNNToolBar)
			Dim objTB As Control = Nothing
			If Len(objITB.ToolBarId) > 0 Then
				objTB = objControl.Page.FindControl(objITB.ToolBarId)
			End If
			Return CType(objTB, DNNToolBar)
		End Function

		Friend Sub NotifyDesigner()
			If IsDesignMode() AndAlso Not MyBase.Site Is Nothing Then
				Dim dh As IDesignerHost = DirectCast(MyBase.Site.Container, IDesignerHost)
				Dim designer As ControlDesigner = CType(dh.GetDesigner(Me), ControlDesigner)
				Dim pd As PropertyDescriptor = TypeDescriptor.GetProperties(Me).Item("Toolbar")
				Dim objArgs As ComponentChangedEventArgs = New ComponentChangedEventArgs(Me, pd, Nothing, Me)
				designer.OnComponentChanged(Me, objArgs)
			End If
		End Sub

#End Region


#Region "Overrides"

		Protected Overrides Sub Render(ByVal writer As System.Web.UI.HtmlTextWriter)
			'do not render
		End Sub
#End Region

#Region "Events"

		Private Sub DNNToolBar_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.PreRender
			If Me.Visible Then
				RegisterToolbarScript()
			End If
		End Sub
#End Region

#Region "Methods"

		Public Function RegisterToolBar(ByVal objAssociatedControl As Control, ByVal strShowEventName As String, ByVal strHideEventName As String, ByVal strToolBarActionHandler As String) As Boolean
			Return RegisterToolBar(objAssociatedControl, strShowEventName, strHideEventName, strToolBarActionHandler, ClientAPI.ScriptPath)
		End Function

		Public Function RegisterToolBar(ByVal objAssociatedControl As Control, ByVal strShowEventName As String, ByVal strHideEventName As String, ByVal strToolBarActionHandler As String, ByVal ToolBarScriptPath As String) As Boolean
			If ClientAPI.BrowserSupportsFunctionality(ClientAPI.ClientFunctionality.DHTML) Then
				DotNetNuke.UI.Utilities.ClientAPI.RegisterClientReference(Me.Page, DotNetNuke.UI.Utilities.ClientAPI.ClientNamespaceReferences.dnn_dom)

                'If Not ClientAPI.IsClientScriptBlockRegistered(Me.Page, "dnn.controls.dnntoolbarstub.js") Then
                '	ClientAPI.RegisterClientScriptBlock(Me.Page, "dnn.controls.dnntoolbarstub.js", "<script src=""" & ToolBarScriptPath & "dnn.controls.dnntoolbarstub.js""></script>")
                'End If
                RegisterClientScriptBlock(Me.Page, "dnn.controls.js")
                RegisterClientScriptBlock(Me.Page, "dnn.controls.dnntoolbarstub.js")

                Dim strJS As String = String.Format("__dnn_toolbarHandler('{0}','{1}','{2}','{3}',{4},'{5}','{6}')", Me.UniqueID, objAssociatedControl.ClientID, Me.BehaviorID, Me.NamingContainer.UniqueID, strToolBarActionHandler, strShowEventName, strHideEventName)
				If TypeOf objAssociatedControl Is WebControl Then
					CType(objAssociatedControl, WebControl).Attributes.Add(strShowEventName, strJS)
				ElseIf TypeOf objAssociatedControl Is HtmlControl Then
					CType(objAssociatedControl, HtmlControl).Attributes.Add(strShowEventName, strJS)
				End If
				Return True
			End If
			Return False
		End Function

		Friend Function ToJSON() As String
			Dim oHash As Hashtable = New Hashtable

			If Len(Me.CssClass) > 0 Then
				oHash.Add("css", "'" & Me.CssClass & "'")
			End If
			If Len(Me.DefaultButtonCssClass) > 0 Then
				oHash.Add("cssb", "'" & Me.DefaultButtonCssClass & "'")
			End If
			If Len(Me.DefaultButtonHoverCssClass) > 0 Then
				oHash.Add("cssbh", "'" & Me.DefaultButtonHoverCssClass & "'")
			End If
			If Me.MouseOutDelay <> 250 Then
				oHash.Add("mod", Me.MouseOutDelay)
			End If
			If Len(Me.Visible) > 0 Then
				oHash.Add("vis", CInt(Me.Visible))
			End If

			Dim sb As System.Text.StringBuilder = New System.Text.StringBuilder
			sb.Append("[")
			For Each objBtn As DNNToolBarButton In Me.Buttons
				If sb.Length > 1 Then sb.Append(",")
				sb.Append(objBtn.ToJSON())
			Next
			sb.Append("]")
			oHash.Add("btns", sb.ToString)

			sb = New System.Text.StringBuilder
			sb.Append("{")
			For Each strKey As String In oHash.Keys
				If sb.Length > 1 Then sb.Append(",")
				sb.Append(strKey & ":" & CStr(oHash(strKey)))
			Next
			sb.Append("}")

			Return sb.ToString
		End Function

		Private Function RegisterToolbarScript() As String
			Dim strId As String = Me.UniqueID
            If Me.ReuseToolBar Then
                If String.IsNullOrEmpty(Me.BehaviorID) Then
                    strId = Me.ID
                Else
                    strId = Me.BehaviorID
                End If
            End If
                If Not ClientAPI.IsClientScriptBlockRegistered(Me.Page, strId & "_toolbar") Then
                    If ClientAPI.BrowserSupportsFunctionality(ClientAPI.ClientFunctionality.DHTML) Then
                        ClientAPI.RegisterClientReference(Me.Page, ClientAPI.ClientNamespaceReferences.dnn)
                        ClientAPI.RegisterStartUpScript(Me.Page, strId & "_toolbar", String.Format("<script type=""text/javascript"">dnn.controls.toolbars['{0}']={1};</script>", strId, Me.ToJSON))
                    End If
                End If
                If ClientAPI.UseExternalScripts = False Then
                    ClientAPI.RegisterEmbeddedResource(Me.Page, "dnn.controls.dnntoolbar.js", Me.GetType())
                    ClientAPI.RegisterEmbeddedResource(Me.Page, "dnn.controls.dnntoolbarstub.js", Me.GetType())
                End If
        End Function

		Private Function FindAttachedControl(ByVal objControl As Control) As Control
			If TypeOf objControl Is IDNNToolBar Then
				If CType(objControl, IDNNToolBar).ToolBarId = Me.ID Then
					Return objControl
				End If
			End If
			Dim c As Control
			Dim objCtl As Control
			For Each objCtl In objControl.Controls
				Dim t As Control = FindAttachedControl(objCtl)
				If Not t Is Nothing Then
					Return t
				End If
			Next
			Return Nothing
		End Function

#End Region

	End Class
End Namespace
