'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2009
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System.ComponentModel
Imports System.Web.UI
Imports DotNetNuke.UI.WebControls

Namespace DotNetNuke.UI.Design.WebControls
	Public Class DNNToolBarButtonActionTypeConverter : Inherits TypeConverter
		'--- This class provides enumerators for the SolpartMenu.MenuEffects.ShadowDir property ---'
		Public Overloads Overrides Function GetStandardValues(ByVal context As ITypeDescriptorContext) As TypeConverter.StandardValuesCollection
			Dim objCol As Collection = New Collection
			For Each strAction As String In CType(context.Instance, DNNToolBarButton).CommonActions
				objCol.Add(strAction)
			Next
			If SupportsActions(context) Then
				Dim oInstance As IDNNToolBarSupportedActions = CType(AttachedControl(context), IDNNToolBarSupportedActions)
				For Each strAction As String In oInstance.Actions
					objCol.Add(strAction)
				Next
			End If
			Return New TypeConverter.StandardValuesCollection(objCol)
		End Function

		Public Overloads Overrides Function GetStandardValuesSupported(ByVal context As ITypeDescriptorContext) As Boolean
			Return SupportsActions(context)
		End Function

		Public Overloads Overrides Function GetStandardValuesExclusive(ByVal context As ITypeDescriptorContext) As Boolean
			Return False
		End Function

		Private m_objAttached As Control
		Private Function AttachedControl(ByVal context As ITypeDescriptorContext) As Control
			If m_objAttached Is Nothing Then
				Dim objTB As DNNToolBar = CType(CType(context.Instance, DNNToolBarButton).Parent, DNNToolBar)
				m_objAttached = objTB.AttachedControl()
			End If
			Return m_objAttached
		End Function

		Private Function SupportsActions(ByVal context As ITypeDescriptorContext) As Boolean
			Return Not AttachedControl(context) Is Nothing AndAlso TypeOf AttachedControl(context) Is IDNNToolBarSupportedActions
		End Function
	End Class
End Namespace