'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2009
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports DotNetNuke.UI.Utilities
Namespace DotNetNuke.UI.WebControls

	Friend Class DNNTreeUpLevelWriter
		Inherits WebControl
		Implements IDNNTreeWriter
		Private _tree As DnnTree

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' 
		''' </summary>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[jbrinkman]	5/6/2004	Created
		''' </history>
		''' -----------------------------------------------------------------------------
		Public Sub New()
		End Sub

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' 
		''' </summary>
		''' <param name="writer"></param>
		''' <param name="tree"></param>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[jbrinkman]	5/6/2004	Created
		''' </history>
		''' -----------------------------------------------------------------------------
		Public Sub RenderTree(ByVal writer As HtmlTextWriter, ByVal tree As DnnTree) Implements IDNNTreeWriter.RenderTree

			_tree = tree
			RenderControl(writer)
		End Sub

        Protected Function MarshalledProperties() As Hashtable Implements IDNNTreeWriter.MarshalledProperties
            Dim properties As Hashtable = New Hashtable
            If _tree.ImageList.Count > 0 Then
                Dim strList As String = ""
                Dim objNodeImage As NodeImage
                For Each objNodeImage In _tree.ImageList
                    strList &= CStr(IIf(Len(strList) > 0, ",", "")) & objNodeImage.ImageUrl
                Next
                properties.Add("imagelist", strList)
            End If

            properties.Add("postback", ClientAPI.GetPostBackEventReference(_tree, "[NODEID]" & ClientAPI.COLUMN_DELIMITER & "Click"))

            If _tree.PopulateNodesFromClient Then
                If DotNetNuke.UI.Utilities.ClientAPI.BrowserSupportsFunctionality(Utilities.ClientAPI.ClientFunctionality.XMLHTTP) Then
                    properties.Add("callback", DotNetNuke.UI.Utilities.ClientAPI.GetCallbackEventReference(_tree, "'[NODEXML]'", "this.callBackSuccess", "tNode", "this.callBackFail", "this.callBackStatus"))
                Else
                    properties.Add("callback", ClientAPI.GetPostBackClientHyperlink(_tree, "[NODEID]" & ClientAPI.COLUMN_DELIMITER & "OnDemand"))
                End If
                If Len(_tree.CallbackStatusFunction) > 0 Then
                    properties.Add("callbackSF", _tree.CallbackStatusFunction)
                End If

            End If


            Return properties
        End Function

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' 
        ''' </summary>
        ''' <param name="writer"></param>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[jbrinkman]	5/6/2004	Created
        '''		[jhenning] 2/22/2005	Added properties
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Protected Overloads Overrides Sub RenderContents(ByVal writer As HtmlTextWriter)
            writer.AddAttribute(HtmlTextWriterAttribute.Width, "100%")
            writer.AddAttribute(HtmlTextWriterAttribute.Class, "DNNTree")
            writer.AddAttribute(HtmlTextWriterAttribute.Name, _tree.UniqueID)
            writer.AddAttribute(HtmlTextWriterAttribute.Id, _tree.ClientID)        '_tree.UniqueID.Replace(":", "_"))

            'writer.AddAttribute("sysimgpath", _tree.SystemImagesPath)
            'writer.AddAttribute("indentw", _tree.IndentWidth.ToString)
            'If _tree.ExpandCollapseImageWidth <> 12 Then
            '    writer.AddAttribute("expcolimgw", _tree.ExpandCollapseImageWidth.ToString)
            'End If
            'If _tree.CheckBoxes Then writer.AddAttribute("checkboxes", "1")
            'If Len(_tree.Target) > 0 Then writer.AddAttribute("target", _tree.Target)

            'If _tree.ImageList.Count > 0 Then
            '    Dim strList As String = ""
            '    Dim objNodeImage As NodeImage
            '    For Each objNodeImage In _tree.ImageList
            '        strList &= CStr(IIf(Len(strList) > 0, ",", "")) & objNodeImage.ImageUrl
            '    Next
            '    writer.AddAttribute("imagelist", strList)
            'End If

            'css attributes
            'If Len(_tree.DefaultNodeCssClass) > 0 Then writer.AddAttribute("css", _tree.DefaultNodeCssClass)
            'If Len(_tree.DefaultChildNodeCssClass) > 0 Then writer.AddAttribute("csschild", _tree.DefaultChildNodeCssClass)
            'If Len(_tree.DefaultNodeCssClassOver) > 0 Then writer.AddAttribute("csshover", _tree.DefaultNodeCssClassOver)
            'If Len(_tree.DefaultNodeCssClassSelected) > 0 Then writer.AddAttribute("csssel", _tree.DefaultNodeCssClassSelected)
            'If Len(_tree.DefaultIconCssClass) > 0 Then writer.AddAttribute("cssicon", _tree.DefaultIconCssClass)

            'If Len(_tree.JSFunction) > 0 Then writer.AddAttribute("js", _tree.JSFunction)

            'If Len(_tree.WorkImage) > 0 Then writer.AddAttribute("workimg", _tree.WorkImage)
            'If _tree.AnimationFrames <> 5 Then writer.AddAttribute("animf", _tree.AnimationFrames.ToString)
            'writer.AddAttribute("expimg", _tree.ExpandedNodeImage)
            'writer.AddAttribute("colimg", _tree.CollapsedNodeImage)
            'writer.AddAttribute("postback", ClientAPI.GetPostBackEventReference(_tree, "[NODEID]" & ClientAPI.COLUMN_DELIMITER & "Click"))

            'If _tree.PopulateNodesFromClient Then
            '    If DotNetNuke.UI.Utilities.ClientAPI.BrowserSupportsFunctionality(Utilities.ClientAPI.ClientFunctionality.XMLHTTP) Then
            '        writer.AddAttribute("callback", DotNetNuke.UI.Utilities.ClientAPI.GetCallbackEventReference(_tree, "'[NODEXML]'", "this.callBackSuccess", "tNode", "this.callBackFail", "this.callBackStatus"))
            '    Else
            '        writer.AddAttribute("callback", ClientAPI.GetPostBackClientHyperlink(_tree, "[NODEID]" & ClientAPI.COLUMN_DELIMITER & "OnDemand"))
            '    End If
            '    If Len(_tree.CallbackStatusFunction) > 0 Then
            '        writer.AddAttribute("callbackSF", _tree.CallbackStatusFunction)
            '    End If

            'End If

            writer.RenderBeginTag(HtmlTextWriterTag.Div)
            writer.RenderEndTag()
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' 
        ''' </summary>
        ''' <param name="writer"></param>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[jbrinkman]	5/6/2004	Created
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Protected Overloads Overrides Sub RenderChildren(ByVal writer As HtmlTextWriter)
            Dim TempNode As TreeNode
            For Each TempNode In _tree.TreeNodes
                TempNode.Render(writer)
            Next
        End Sub

    End Class
End Namespace
