'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2009
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Diagnostics
Imports DotNetNuke.UI.Utilities
Namespace DotNetNuke.UI.WebControls

	Friend Class TreeNodeWriter
		Implements ITreeNodeWriter
		Shared ReadOnly _expcol As String() = New String(1) {"+", "-"}
		Private _Node As TreeNode

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' 
		''' </summary>
		''' <param name="writer"></param>
		''' <param name="Node"></param>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[jbrinkman]	5/6/2004	Created
		''' </history>
		''' -----------------------------------------------------------------------------
		Public Sub RenderNode(ByVal writer As HtmlTextWriter, ByVal Node As TreeNode) Implements ITreeNodeWriter.RenderNode
			_Node = Node
			Render(writer)
		End Sub

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' 
		''' </summary>
		''' <param name="writer"></param>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[jbrinkman]	5/6/2004	Created
		'''		[Jon Henning] 11/28/2005 Added iscrawler logic
		''' </history>
		''' -----------------------------------------------------------------------------
		Protected Sub Render(ByVal writer As HtmlTextWriter)
			RenderContents(writer)
			If _Node.HasNodes AndAlso (_Node.IsExpanded OrElse _Node.DNNTree.IsCrawler) Then
				writer.AddAttribute(HtmlTextWriterAttribute.Class, "Child")
				writer.AddAttribute(HtmlTextWriterAttribute.Width, "100%")
				writer.RenderBeginTag(HtmlTextWriterTag.Div)
				RenderChildren(writer)
				writer.RenderEndTag()
			End If
		End Sub

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' 
		''' </summary>
		''' <param name="writer"></param>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[jbrinkman]	5/6/2004	Created
		''' </history>
		''' -----------------------------------------------------------------------------
		Protected Sub RenderContents(ByVal writer As HtmlTextWriter)

			RenderOpenTag(writer)
			If _Node.DNNTree.IndentWidth = 0 Then _Node.DNNTree.IndentWidth = 9 'keep old default

			If _Node.Level > 0 Then
				RenderSpacer(writer, _Node.Level * _Node.DNNTree.IndentWidth)
			End If

			RenderExpandNodeIcon(writer)

			RenderNodeCheckbox(writer)

			RenderNodeIcon(writer)

			RenderNodeText(writer)

			writer.RenderEndTag()

		End Sub

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' 
		''' </summary>
		''' <param name="writer"></param>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[jbrinkman]	5/6/2004	Created
		''' </history>
		''' -----------------------------------------------------------------------------
		Protected Sub RenderOpenTag(ByVal writer As HtmlTextWriter)
			Dim NodeClass As String = "Node"

			'writer.AddAttribute(HtmlTextWriterAttribute.Class, GetNodeCss(_Node))
			writer.AddAttribute(HtmlTextWriterAttribute.Name, _Node.ID)
            writer.AddAttribute(HtmlTextWriterAttribute.Id, _Node.ID.Replace(TreeNode._separator, "_"))
			writer.RenderBeginTag(HtmlTextWriterTag.Div)
		End Sub

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' 
		''' </summary>
		''' <param name="writer"></param>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[jbrinkman]	5/6/2004	Created
		'''		[Jon Henning] 11/28/2005 Added iscrawler logic
		''' </history>
		''' -----------------------------------------------------------------------------
		Protected Sub RenderExpandNodeIcon(ByVal writer As HtmlTextWriter)
			If _Node.HasNodes Then
				Dim _link As HyperLink = New HyperLink
				Dim _image As Image = New Image
				If _Node.IsExpanded OrElse _Node.DNNTree.IsCrawler Then
					_link.Text = _expcol(1)
					If Len(_Node.DNNTree.ExpandedNodeImage) > 0 Then
						_image.ImageUrl = _Node.DNNTree.ExpandedNodeImage
					End If
				Else
					_link.Text = _expcol(0)
					If Len(_Node.DNNTree.CollapsedNodeImage) > 0 Then
						_image.ImageUrl = _Node.DNNTree.CollapsedNodeImage
					End If
				End If
				'If _Node.PopulateOnDemand Then	'handled in postback handler
				'	_link.NavigateUrl = ClientAPI.GetPostBackClientHyperlink(_Node.DNNTree, _Node.ID & ",OnDemand")
				'Else
				_link.NavigateUrl = ClientAPI.GetPostBackClientHyperlink(_Node.DNNTree, _Node.ID)
				'End If
				If Len(_image.ImageUrl) > 0 Then
					_link.RenderBeginTag(writer)
					_image.RenderControl(writer)
					_link.RenderEndTag(writer)
				Else
					_link.RenderControl(writer)
				End If
				_image = Nothing
				_link = Nothing
			Else
				RenderSpacer(writer, _Node.DNNTree.ExpandCollapseImageWidth)
			End If
			writer.Write("&nbsp;")
		End Sub

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' 
		''' </summary>
		''' <param name="writer"></param>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[jbrinkman]	5/6/2004	Created
		''' </history>
		''' -----------------------------------------------------------------------------
		Protected Sub RenderNodeCheckbox(ByVal writer As HtmlTextWriter)
			If _Node.DNNTree.CheckBoxes Then
				Dim _checkbox As CheckBox = New CheckBox
				_checkbox.ID = _Node.ID + TreeNode._separator + TreeNode._checkboxIDSufix
				_checkbox.Checked = _Node.Selected
				Dim strJS As String = ""
				If Len(_Node.JSFunction) > 0 Then
					If _Node.JSFunction.EndsWith(";") = False Then _Node.JSFunction &= ";"
					strJS &= _Node.JSFunction
				End If
				If Len(_Node.DNNTree.JSFunction) > 0 Then
					If _Node.DNNTree.JSFunction.EndsWith(";") = False Then _Node.DNNTree.JSFunction &= ";"
					strJS &= _Node.DNNTree.JSFunction
				End If

				Dim strClick As String = ClientAPI.GetPostBackClientHyperlink(_Node.DNNTree, _Node.ID & ClientAPI.COLUMN_DELIMITER & "Click").Replace("javascript:", "") & ";"
				Dim strCheck As String = ClientAPI.GetPostBackClientHyperlink(_Node.DNNTree, _Node.ID & ClientAPI.COLUMN_DELIMITER & "Checked").Replace("javascript:", "") & ";"
				If _Node.Selected = False Then
					If Len(strJS) > 0 Then
						strJS = "if (eval(""" & strJS.Replace("""", """""") & """) != false) "
						strJS &= strClick & " else " & strCheck
					Else
						strJS &= strClick
					End If
				Else
					strJS = strCheck
				End If

				'_checkbox.Attributes.Add("onclick", ClientAPI.GetPostBackClientHyperlink(_Node.DNNTree, _Node.ID & ",Unchecked"))
				'Else
				_checkbox.Attributes.Add("onclick", strJS)
				'End If
				_checkbox.RenderControl(writer)
				_checkbox = Nothing
				writer.Write("&nbsp;")
			End If
		End Sub

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' 
		''' </summary>
		''' <param name="writer"></param>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[jbrinkman]	5/6/2004	Created
		''' </history>
		''' -----------------------------------------------------------------------------
		Protected Sub RenderNodeIcon(ByVal writer As HtmlTextWriter)
			Dim oSpan As Label = New Label
			If Len(_Node.CSSIcon) > 0 Then
				oSpan.CssClass = _Node.CSSIcon
			ElseIf Len(_Node.DNNTree.DefaultIconCssClass) > 0 Then
				oSpan.CssClass = _Node.DNNTree.DefaultIconCssClass
			End If
			oSpan.RenderBeginTag(writer)

			If _Node.ImageIndex > -1 Then
				Dim _NodeImage As NodeImage = _Node.DNNTree.ImageList(_Node.ImageIndex)
				If Not (_NodeImage Is Nothing) Then
					Dim _image As Image = New Image
					_image.ImageUrl = _NodeImage.ImageUrl
					_image.RenderControl(writer)
					writer.Write("&nbsp;")
				End If
			End If
			oSpan.RenderEndTag(writer)
		End Sub

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' 
		''' </summary>
		''' <param name="writer"></param>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[jbrinkman]	5/6/2004	Created
		''' </history>
		''' -----------------------------------------------------------------------------
		Protected Sub RenderNodeText(ByVal writer As HtmlTextWriter)
			'Dim _label As Label = New Label
			Dim _link As HyperLink = New HyperLink
			Dim strJS As String = ""

			'_label.Text = _Node.Text
			_link.Text = _Node.Text

			If Len(_Node.JSFunction) > 0 Then
				If _Node.JSFunction.EndsWith(";") = False Then _Node.JSFunction &= ";"
				strJS &= _Node.JSFunction
			ElseIf Len(_Node.DNNTree.JSFunction) > 0 Then
				If _Node.DNNTree.JSFunction.EndsWith(";") = False Then _Node.DNNTree.JSFunction &= ";"
				strJS &= _Node.DNNTree.JSFunction
			End If

			If _Node.Enabled Then
				Select Case _Node.ClickAction
					Case eClickAction.PostBack, eClickAction.Expand
						If Len(strJS) > 0 Then strJS = "if (eval(""" & strJS.Replace("""", """""") & """) != false) "
						strJS &= ClientAPI.GetPostBackClientHyperlink(_Node.DNNTree, _Node.ID & ClientAPI.COLUMN_DELIMITER & "Click").Replace("javascript:", "")
					Case eClickAction.Navigate
						If Len(strJS) > 0 Then strJS = "if (eval(""" & strJS.Replace("""", """""") & """) != false) "
						If Len(_Node.DNNTree.Target) > 0 Then
							strJS &= "window.frames." & _Node.DNNTree.Target & ".location.href='" & _Node.NavigateURL & "'; void(0);"							'FOR SOME REASON THIS DOESNT WORK UNLESS WE HAVE CODE AFTER THE SETTING OF THE HREF...
						Else
							strJS &= "window.location.href='" & _Node.NavigateURL & "';"
						End If

				End Select

				_link.NavigateUrl = "javascript:" & strJS
			End If

			If Len(_Node.ToolTip) > 0 Then
				'_label.ToolTip = _Node.ToolTip
				_link.ToolTip = _Node.ToolTip
			End If
			'_label.CssClass = "NodeText"
			'_label.RenderControl(writer)

			Dim sCSS As String = GetNodeCss(_Node)
			If Len(sCSS) > 0 Then _link.CssClass = sCSS
			'If _Node.Selected Then
			'	If Len(_Node.DNNTree.DefaultNodeCssClassSelected) > 0 Then _link.CssClass = _Node.DNNTree.DefaultNodeCssClassSelected
			'Else
			'	_link.CssClass = _Node.CSSClass
			'End If

			_link.RenderControl(writer)
		End Sub

		Private Function GetNodeCss(ByVal oNode As TreeNode) As String
			Dim sNodeCss As String = oNode.DNNTree.CssClass

			If oNode.Level > 0 Then sNodeCss = oNode.DNNTree.DefaultChildNodeCssClass
			If Len(oNode.CSSClass) > 0 Then sNodeCss = oNode.CSSClass

			If oNode.Selected Then
				If Len(oNode.CSSClassSelected) > 0 Then
					sNodeCss &= " " & oNode.CSSClassSelected
				Else
					sNodeCss &= " " & oNode.DNNTree.DefaultNodeCssClassSelected
				End If
			End If

			Return sNodeCss
		End Function

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' 
		''' </summary>
		''' <param name="writer"></param>
		''' <param name="Width"></param>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[jbrinkman]	5/6/2004	Created
		''' </history>
		''' -----------------------------------------------------------------------------
		Protected Sub RenderSpacer(ByVal writer As HtmlTextWriter, ByVal Width As Integer)
			writer.AddStyleAttribute("width", Width.ToString & "px")
			writer.AddStyleAttribute("height", "1px")
			writer.AddAttribute("src", _Node.DNNTree.SystemImagesPath & "spacer.gif")
			writer.RenderBeginTag(HtmlTextWriterTag.Img)
			writer.RenderEndTag()
		End Sub

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' 
		''' </summary>
		''' <param name="writer"></param>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[jbrinkman]	5/6/2004	Created
		''' </history>
		''' -----------------------------------------------------------------------------
		Protected Sub RenderChildren(ByVal writer As HtmlTextWriter)
			For Each _elem As TreeNode In _Node.TreeNodes
				_elem.Render(writer)
			Next
		End Sub

	End Class
End Namespace
